#include "H/Function_Init.H"

char Array[] = {0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xaa,0xbb,0xcc,0xdd,0xee,0xff};
typedef struct
{
    char a3;        //λַ
    char a2;        //θߵַ
    char a1;        //ε͵ַ
    char a0;        //λַ
}Value_Typedef;    
typedef union
{
    Value_Typedef reg; 
    unsigned long int result;  //ս
}Result_Typedef;

unsigned long int temp = 0x00;  //ս
Result_Typedef CRC_Result;

void CRC_Hardware_Init(void);
void CRC_Software_Init(char array[]);

/*****************************************************
*ƣvoid CRC_Test(void)
*ܣCRC
*ڲvoid
*ڲvoid
*****************************************************/
void CRC_Test(void)
{
    //ӲУ
    CRC_Hardware_Init();
    //У
    CRC_Software_Init(Array);
}

/*****************************************************
*ƣvoid CRC_Hardware_Init(void)
*ܣCRCӲУʼ
*ڲvoid
*ڲvoid
*****************************************************/
void CRC_Hardware_Init(void)
{
    bit EABIT = EA;
    EA = 0;
    OPERCON |= 0x01;  //ӲУ
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
  _nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();

    CRCINX = 0x00;
    CRC_Result.reg.a0 = CRCREG;   //byte
    CRC_Result.reg.a1 = CRCREG;   //εbyte
    CRC_Result.reg.a2 = CRCREG;   //θbyte
    CRC_Result.reg.a3 = CRCREG;   //byte
    temp = CRC_Result.result;     //
    EA = EABIT;
}

/*****************************************************
*ƣvoid CRC_Software_Init(char array[])
*ܣCRCУʼ
*ڲvoid
*ڲvoid
*****************************************************/
void CRC_Software_Init(char array[])
{
    int i = 0;
    bit EABIT = EA;
    EA = 0;
    OPERCON |= 0x02;             //У
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
  _nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
    for(i=0; i<16; i++)      //У鷶Χ
    {
        CRCREG = array[i];   //ҪУĵֵַŵĴ
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
  _nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();
	_nop_();          
    }
    CRCINX = 0x00;
    CRC_Result.reg.a0 = CRCREG;   //byte
    CRC_Result.reg.a1 = CRCREG;   //εbyte
    CRC_Result.reg.a2 = CRCREG;   //θbyte
    CRC_Result.reg.a3 = CRCREG;   //byte
    temp = CRC_Result.result;     //
    EA = EABIT;
}