#include "H/Function_Init.H"

//ѡһģʽ
#define  Uart0   0
#define  TWI0    1
#define  SPI0    2

#define  SSI0_Mode  Uart0

void Uart0_Init(uint Freq,unsigned long int baud);
void TWI0_Init(void);
void SPI0_Init(void);

bit Uart0SendFlag = 0;    //Uart0жϱ־λ
bit Uart0ReceiveFlag = 0; //Uart0жϱ־λ
bit SPI0Flag = 0;         //SPI0ݴɱ־λ
bit TWI0Flag = 0;         //TWI0жϱ־λ

/*****************************************************
*ƣvoid SSI0_Test(void)
*ܣSSI0
*ڲvoid
*ڲvoid
*****************************************************/
void SSI0_Test(void)
{
#if (SSI0_Mode == Uart0)
	Uart0_Init(32,9600);
	while(1)
	{
		US0CON3 = 0xAA;
		while(!(US0CON0&0x02));
		US0CON0 &= ~0x02;
	}
#endif
	
#if (SSI0_Mode == TWI0)
	TWI0_Init();
	while(1)
	{
		US0CON1 |= 0x20;    //ʼ
		while(!TWI0Flag);
        TWI0Flag = 0;		
		US0CON3 = 0x10;	    //͵ַ
        while(!TWI0Flag);
        TWI0Flag = 0;
        US0CON3 = 0x55;	    //͵ַ
        while(!TWI0Flag);
        TWI0Flag = 0;
		Delay(100);
		US0CON1 |= 0x10;
		Delay(100);
	}
#endif

#if (SSI0_Mode == SPI0)
	SPI0_Init();
	while(1)
	{
		US0CON2 = 0xAA;
		while(!SPI0Flag);
		SPI0Flag = 0;
        Delay(1000);
	}
#endif	
}
/*****************************************************
*ƣvoid Uart0_Init(uint Freq,unsigned long int baud)
*ܣUart0жϳʼ
*ڲFreq-Ƶbaud-
*ڲvoid
*****************************************************/
void Uart0_Init(uint Freq,unsigned long int baud)
{
	P2CON &= 0xFC;    //TX/RXΪ
	P2PH  |= 0x03;
	
	OTCON |= 0x30;    //нӿSSI0ѡUart0ͨ
	US0CON0 = 0x50;   //ͨŷʽΪģʽһ
	US0CON1 = Freq*1000000/baud;   //ʵλ
	US0CON2 = (Freq*1000000/baud)>>8;   //ʸλ
//	IE1 |= 0x01;      //SSI0ж
//    EA = 1;	
}

/*****************************************************
*ƣvoid TWI0_Init(void)
*ܣTWI0ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void TWI0_Init(void)
{
	OTCON |= 0x20;   //ѡTWI0ģʽ
	US0CON0 = 0x80;  //ģʽ ʹӦ־λ
	US0CON1 = 0x05;  //---- xxxx  xΪʱ
	IE1 |= 0x01;
	EA = 1;
}

/*****************************************************
*ƣvoid SPI0_Init(void)
*ܣSPI0ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void SPI0_Init(void)
{
	OTCON |= 0X10;    //ѡSPI0ģʽ
	US0CON0 = 0x3F;   //SPI0Ϊ豸SCKʱΪߵƽSCKڵڶزɼݣʱΪFsys/128
	US0CON1 = 0x01;   //MSBȷͣ8λ䣬ж
	US0CON0 |= 0x80;  //SPI0
	IE1 |= 0x01;
	EA = 1;
}


/*****************************************************
*ƣvoid TWI0/PI/UART1_Int() interrupt 7
*ܣSSI0жϺ
*ڲvoid
*ڲvoid
*****************************************************/
#if (SSI0_Mode == Uart0)
void SSI0_Int()     //UART0жϺ
{
	if(US0CON0&0x02)    //ͱ־λж
	{
		US0CON0 &= 0xFD;
		Uart0SendFlag = 1;
	}
	if((US0CON0&0x01))  //ձ־λж
	{
		US0CON0 &= 0xFE;
		Uart0ReceiveFlag = 1;
	}	
}
#endif

#if (SSI0_Mode == TWI0)
void SSI0_Int()     //TWI0жϺ
{
	if(US0CON0&0x40)
	{
		US0CON0 &= 0xbf;  //ж
		TWI0Flag = 1;
	}	
}
#endif 

#if (SSI0_Mode == SPI0)
void SSI0_Int(void)   //SPI0жϺ
{	  
	if(US0CON1&0X08)    //ͻձ־ж
	{
		US0CON1 &= ~0X08;
	}
	if(US0CON1&0X80)    //ݴ־λж
	{
		US0CON1 &= ~0X80;
		SPI0Flag = 1;
	}
}
#endif 