#include "H/Function_Init.H"

//ѡһģʽ
#define  Uart1   0
#define  TWI1    1
#define  SPI1    2

#define  SSI1_Mode  Uart1

void Uart1_Init(uint Freq,unsigned long int baud);
void TWI1_Init(void);
void SPI1_Init(void);

bit Uart1SendFlag = 0;    //Uart1жϱ־λ
bit Uart1ReceiveFlag = 0; //Uart1жϱ־λ
bit SPI1Flag = 0;         //SPI1ݴɱ־λ
bit TWI1Flag = 0;         //TWI1жϱ־λ

/*****************************************************
*ƣvoid SSI1_Test(void)
*ܣSSI1
*ڲvoid
*ڲvoid
*****************************************************/
void SSI1_Test(void)
{
#if (SSI1_Mode == Uart1)
	Uart1_Init(32,9600);
	while(1)
	{
		US1CON3 = 0xAA;
		while(!Uart1SendFlag);
		Uart1SendFlag = 0;
	}
#endif
	
#if (SSI1_Mode == TWI1)
	TWI1_Init();
	while(1)
	{
		US1CON1 |= 0x20;    //ʼ
		while(!TWI1Flag);
        TWI1Flag = 0;		
		US1CON3 = 0x10;	    //͵ַ
        while(!TWI1Flag);
        TWI1Flag = 0;
        US1CON3 = 0x55;	    //͵ַ
        while(!TWI1Flag);
        TWI1Flag = 0;
		Delay(100);
		US1CON1 |= 0x10;
		Delay(100);
	}
#endif

#if (SSI1_Mode == SPI1)
	SPI1_Init();
	while(1)
	{
		US1CON2 = 0xAA;
		while(!SPI1Flag);
		SPI1Flag = 0;
        Delay(1000);
	}
#endif	
}
/*****************************************************
*ƣvoid Uart1_Init(uint Freq,unsigned long int baud)
*ܣUart1жϳʼ
*ڲFreq-Ƶbaud-
*ڲvoid
*****************************************************/
void Uart1_Init(uint Freq,unsigned long int baud)
{
	P0CON &= 0xF3;    //TX/RXΪ
	P0PH  |= 0x0C;
	
	OTCON |= 0xC0;    //нӿSSI1ѡUart1ͨ
	US1CON0 = 0x50;   //ͨŷʽΪģʽһ
	US1CON1 = Freq*1000000/baud;   //ʵλ
	US1CON2 = (Freq*1000000/baud)>>8;   //ʸλ
	IE2 |= 0x01;      //SSI1ж
    EA = 1;	
}

/*****************************************************
*ƣvoid TWI1_Init(void)
*ܣTWI1ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void TWI1_Init(void)
{
	OTCON |= 0x80;   //ѡTWI1ģʽ
	US1CON0 = 0x80;  //ģʽ ʹӦ־λ
	US1CON1 = 0x05;  //---- xxxx  xΪʱ
	IE2 |= 0x01;
	EA = 1;
}

/*****************************************************
*ƣvoid SPI1_Init(void)
*ܣSPI1ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void SPI1_Init(void)
{
	OTCON |= 0X40;    //ѡSPI1ģʽ
	US1CON0 = 0x3F;   //SPI1Ϊ豸SCKʱΪߵƽSCKڵڶزɼݣʱΪFsys/128
	US1CON1 = 0x01;   //MSBȷͣ8λ䣬ж
	US1CON0 |= 0x80;  //SPI1
	IE2 |= 0x01;
	EA = 1;
}


/*****************************************************
*ƣvoid TWI1/PI/UART1_Int() interrupt 7
*ܣSSI1жϺ
*ڲvoid
*ڲvoid
*****************************************************/
#if (SSI1_Mode == Uart1)
void Uart1_Int() interrupt 15   //Uart1жϺ
{
	if(US1CON0&0x02)    //ͱ־λж
	{
		US1CON0 &= 0xFD;
		Uart1SendFlag = 1;
	}
	if((US1CON0&0x01))  //ձ־λж
	{
		US1CON0 &= 0xFE;
		Uart1ReceiveFlag = 1;
	}	
}
#endif

#if (SSI1_Mode == TWI1)
void TWI1_Int() interrupt 15     //TWI1жϺ
{
	if(US1CON0&0x40)
	{
		US1CON0 &= 0xbf;  //ж
		TWI1Flag = 1;
	}	
}
#endif 

#if (SSI1_Mode == SPI1)
void SpiInt(void) interrupt 15    //SPI1жϺ
{	  
	if(US1CON1&0X08)    //ͻձ־ж
	{
		US1CON1 &= ~0X08;
	}
	if(US1CON1&0X80)    //ݴ־λж
	{
		US1CON1 &= ~0X80;
		SPI1Flag = 1;
	}
}
#endif 