#include "H\Function_Init.H"

#define SC_CK   P05
#define SC_DAT  P20
#define SC_PWR  P15
#define SC_RST  P16
#define SC_CD   P17

bit TC_Flag = 0;
bit RC_Flag = 0;
bit WTRT_Flag = 0;
bit TBUSY_Flag = 0;
bit RBUSY_Flag = 0;
bit WTER_Flag = 0;
bit FER_Flag = 0;
bit TPER_Flag = 0;
bit RPER_Flag = 0;
bit TOVF_Flag = 0;
bit ROVF_Flag = 0;


unsigned char Receive_ATR_Info[16];//ATRϢ
void SmartCard_Init(void);
void Timer_Delay(unsigned int count);
void SC_Activation_ColdReduction(void);
void SC_WarmReset(void);

/*****************************************************
*ƣvoid SmartCard_Test(void)
*ܣܿ
*ڲvoid
*ڲvoid
*****************************************************/
void SmartCard_Test(void)
{
	SmartCard_Init();//ܿʼ
    SC_Activation_ColdReduction();//临λȡATR
//    void SC_WarmReset();//ůλȡATR
	while(1)
	{
	}
}

/*****************************************************
*ƣvoid SmartCard_Init(void)
*ܣܿʼ
*ڲvoid
*ڲvoid
*****************************************************/
void SmartCard_Init(void)
{
    OTCON &= 0xCF;     //ѡSCͨ
    US0CON0 = 0x30;    //ͨIO
    US0CON0 &= ~0x04;  //Լѡ
    US0CON1 = 0x74; 
    US0CON2 |= 0x81;   //SCCK  372
    US0CON4 = 0x03;    //չʱ       
//    IE1 = 0x01;        //жʹ
//    EA = 1;            //жʹ
}

/*****************************************************
*ƣvoid SmartCard_Init(void)
*ܣܿ临λĽATR
*ڲvoid
*ڲvoid
*****************************************************/
void SC_Activation_ColdReduction(void)
{
    int i = 0;
    US0CON0 &= ~0x40;  //رSC_CLK      
    SC_RST = 0;
    SC_PWR = 1;
    US0CON0 &= 0x7f;  //DATͨIO
    SC_DAT = 1;
    Timer_Delay(42);
    US0CON0 |= 0x40;  //SC_CLK
    US0CON0 |= 0x80;  //DATΪDAT
    Timer_Delay(250);
    SC_RST = 1;
    Timer_Delay(400);
    
    //
    US0CON0 &= ~0X20;   //ʹ
    for(i=0; i<16; i++) //ATRΪ15byte
    {  
        US0CON5 &= 0x7f;  //лд״̬Ĵ        
        while(US0CON5 & 0x04);
        while(!(US0CON5 & 0x20));        
        US0CON5 |= 0X20;   //д1
        Receive_ATR_Info[i] = US0CON3;
    }
}

/*****************************************************
*ƣvoid SC_WarmReset(void)
*ܣܿůλĽATR
*ڲvoid
*ڲvoid
*****************************************************/
void SC_WarmReset(void)
{
    int i = 0;
    SC_RST = 0;
    Timer_Delay(41);
    SC_DAT = 1;
    Timer_Delay(242);
    SC_RST = 1;
    Timer_Delay(500);
    
    //
    US0CON0 &= ~0X20;   //ʹ
    for(i=0; i<16; i++)
    {    
        US0CON5 &= 0x7f;  //лд״̬Ĵ        
        while(US0CON5 & 0x04);
        while(!(US0CON5 & 0x20));
        US0CON5 |= 0x20;  //д1
        Receive_ATR_Info[i] = US0CON3;
    }
}

/*****************************************************
*ƣvoid SC_Send(unsigned char Data)
*ܣܿ
*ڲData
*ڲvoid
*****************************************************/
void SC_Send(unsigned char Data)
{
    US0CON0 &= ~0x20;  //
    US0CON0 |= 0x20;  //ʹ
    P07 = ~P07;P07 = ~P07;P07 = ~P07;   
    US0CON3 = Data;  
    while(US0CON5 & 0x08);   
    while(!TC_Flag);
    TC_Flag = 0;
}

/*****************************************************
*ƣvoid SC_Receive(void)
*ܣܿ
*ڲvoid
*ڲvoid
*****************************************************/
unsigned char SC_Receive(void)
{
    unsigned char temp = 0x00;
    US0CON0 &= ~0x20;  //ʹ 
    while(US0CON5 & 0x04);
    while(!RC_Flag);  
    RC_Flag = 0;  
    temp = US0CON3; 
    return temp;
}

/*****************************************************
*ƣvoid Timer_Delay(unsigned int count)
*ܣʱ
*ڲcount
*ڲvoid
*****************************************************/
void Timer_Delay(unsigned int count)
{
    for(;count>0;count--)
    {
//        while(!TF0);
//        TF0 = 0;
    }
}

/*****************************************************
*ƣvoid SC_Interrupt() interrupt 7
*ܣжϷ
*ڲvoid
*ڲvoid
*****************************************************/
void SC_Interrupt()
{  
    P07 = ~P07;
    US0CON5 = 0x00;    //д״̬Ĵ
    if(US0CON5 & 0x40)  //ɱ־λ
    {
        US0CON5 |= 0x40;
        TC_Flag = 1;
    }
    
    if(US0CON5 & 0x20)  //ɱ־λ
    {
        US0CON5 |= 0x20;
        RC_Flag = 1;
    }
    
    if(US0CON5 & 0x10)  //ȴط־λ
    {
        WTRT_Flag = 1;
    }
    if(US0CON5 & 0x08)  //ݷæ־λ
    {
        TBUSY_Flag = 1;
    }
    if(US0CON5 & 0x04)  //ݽæ־λ
    {
        RBUSY_Flag = 1;
    }
    if(US0CON5 & 0x02)  //ȴʱ־λ
    {
        US0CON5 |= 0x02;
        WTER_Flag = 1;
    }
    if(US0CON5 & 0x01)  //֡־λ
    {
        US0CON5 |= 0x01;
        FER_Flag = 1;
    }
    
    US0CON5 = 0x80;    //дϢĴ
    if(US0CON5 & 0x08)  //ż־λ
    {
        US0CON5 |= 0x08;
        TPER_Flag = 1;
    }
    if(US0CON5 & 0x04)  //ż־λ
    {
        US0CON5 |= 0x04;
        RPER_Flag = 1;
    }
    if(US0CON5 & 0x02)  //TXж״̬־
    {
        US0CON5 |= 0x02;
        TOVF_Flag = 1;
    }
    if(US0CON5 & 0x01)  //־λ
    {
        US0CON5 |= 0x01;
        ROVF_Flag = 1;
    }
}