/*--------------------------------------------------------------------------
SC95F852x_C.H

C Header file for SC95F852x microcontroller.
Copyright (c) 2020 Shenzhen SinOne Chip Electronic CO., Ltd.
All rights reserved.
Ԫ΢ӹɷ޹˾
汾:  V1.0    
:  2020.05.13
--------------------------------------------------------------------------*/
#ifndef _SC95F852x_H_
#define _SC95F852x_H_

/* ------------------- ֽڼĴ-------------------- */
///*CPU*/
sfr   ACC	  = 0xE0;	  //ۼ
sfr   B	      = 0xF0;	  //ͨüĴB		
sfr   PSW	  = 0xD0;	  //״̬
sfr   DPS	  = 0x86;     //ѡĴ
sfr   DPH1    = 0x85;	  //DPH1ָ8λ	
sfr   DPL1    = 0x84;     //DPL1ָ8λ	
sfr   DPH	  = 0x83;	  //DPHָ8λ		
sfr   DPL	  = 0x82;	  //DPLָ8λ		
sfr   SP	  = 0x81;	  //ջָ	
		
/*system*/
sfr	  PCON    = 0x87;	  //ԴƼĴ

/*interrupt*/
sfr	  IP2     = 0xBA;     //жȼƼĴ2
sfr	  IP1     = 0xB9;     //жȼƼĴ1
sfr	  IP	  = 0xB8;	  //жȨƼĴ
sfr	  IE	  = 0xA8;	  //жϿƼĴ
sfr	  IE1     = 0xA9;  	  //жϿƼĴ1
sfr	  IE2     = 0xAA;     //жϿƼĴ2

/*PORT*/
sfr   P5PH    = 0xDA;	  //P5ģʽƼĴ		
sfr	  P5CON	  = 0xD9;	  //P5ģʽƼĴ		
sfr   P5	  = 0xD8;	  //P5ݼĴ
sfr   P2PH    = 0xA2;	  //P2ģʽƼĴ		
sfr	  P2CON	  = 0xA1;	  //P2ģʽƼĴ		
sfr   P2	  = 0xA0;	  //P2ݼĴ
sfr   P1PH    = 0x92;	  //P1ģʽƼĴ		
sfr	  P1CON   = 0x91;	  //P1ģʽƼĴ	
sfr   P1	  = 0x90;	  //P1ݼĴ
sfr	  P0PH    = 0x9B;	  //P0ģʽƼĴ		
sfr	  P0CON   = 0x9A;	  //P0ģʽƼĴ		
sfr   P0	  = 0x80;	  //P0ݼĴ
sfr   IOHCON0 = 0x96;	  //IOH0üĴ
sfr   IOHCON1 = 0x97;	  //IOH1üĴ

/*TIMER*/
sfr   TMCON   = 0x8E;	  //ʱƵʿƼĴ
sfr   TH1	  = 0x8D;	  //ʱ18λ
sfr   TH0	  = 0x8C;	  //ʱ08λ
sfr   TL1	  = 0x8B;	  //ʱ18λ
sfr   TL0	  = 0x8A;	  //ʱ08λ
sfr   TMOD	  = 0x89;	  //ʱ0/1ģʽĴ
sfr   TCON	  = 0x88;     //ʱ0/1ƼĴ
sfr   TXCON   = 0xC8;     //ʱ2/3/4ƼĴ
sfr   TXMOD   = 0xC9;     //ʱ2/3/4ģʽĴ
sfr   RCAPXL  = 0xCA;     //ʱ2/3/4/׽8λ
sfr   RCAPXH  = 0xCB;     //ʱ2/3/4/׽8λ
sfr   TLX     = 0xCC;     //ʱ2/3/48λ
sfr   THX     = 0xCD;     //ʱ2/3/48λ
sfr   TXINX   = 0xCE;     //ʱƼĴָ

/*ADC*/
sfr	  ADCCFG0 = 0xAB;	  //ADCüĴ0
sfr	  ADCCFG1 = 0xAC;	  //ADCüĴ1
sfr	  ADCCFG2 = 0xB5;	  //ADCüĴ2
sfr   ADCCON  = 0xAD;     //ADCƼĴ
sfr   ADCVL	  = 0xAE;	  //ADC Ĵ
sfr   ADCVH	  = 0xAF;	  //ADC Ĵ

/*PWM*/
sfr   PWMCFG  = 0xD1;	  //PWMüĴ
sfr   PWMCON0 = 0xD2;	  //PWMüĴ
sfr   PWMCON1 = 0xD3;	  //PWMƼĴ
sfr   PWMPDL  = 0xD4;	  //PWMüĴ8λ
sfr   PWMPDH  = 0xD5;	  //PWMüĴ8λ
sfr   PWMDFR  = 0xD6;	  //PWM0üĴ
sfr   PWMFLT  = 0xD7;	  //PWMϼüĴ

//
///*WatchDog*/
sfr	  BTMCON  = 0xFB;     //ƵʱƼĴ
sfr   WDTCON  = 0xCF;     //WDTƼĴ

sfr   OTCON   = 0X8F;	  //ƼĴ

/*INT*/
sfr   INT0F   = 0xB4; 	  //INT0 ½жϿƼĴ
sfr   INT0R   = 0xBB; 	  //INT0 ϽжϿƼĴ
sfr   INT1F   = 0xBC; 	  //INT2 ½жϿƼĴ
sfr   INT1R   = 0xBD; 	  //INT2 ϽжϿƼĴ
sfr   INT2F   = 0xBE; 	  //INT2 ½жϿƼĴ
sfr   INT2R   = 0xBF; 	  //INT2 ϽжϿƼĴ

/*IAP */
sfr   IAPCTL  = 0xF6;	  //IAPƼĴ
sfr   IAPDAT  = 0xF5;	  //IAPݼĴ
sfr   IAPADE  = 0xF4;     //IAPչַĴ
sfr   IAPADH  = 0xF3;	  //IAPдַλĴ
sfr   IAPADL  = 0xF2;	  //IAPдַ8λĴ
sfr   IAPKEY  = 0xF1;	  //IAPĴ

/*UART*/
sfr   SCON    = 0x98;     //ڿƼĴ
sfr   SBUF    = 0x99;  	  //ݻĴ


/*USCI0*/
sfr   US0CON0 = 0x95;     //SPI0ƼĴ0
sfr   US0CON1 = 0x9D;     //SPI0ƼĴ1
sfr   US0CON2 = 0x9E;     //SP10ƼĴ2
sfr   US0CON3 = 0x9F;     //SPI0ݼĴ
sfr   US0CON4 = 0xB6;     //EGTչʱĴ
sfr   US0CON5 = 0xB7;     //SCSTA0 SC״̬Ĵ

/*USCI1*/
sfr   US1CON0 = 0xA4;     //SPI1ƼĴ0
sfr   US1CON1 = 0xA5;     //SPI1ƼĴ1
sfr   US1CON2 = 0xA6;     //SPI1ƼĴ2
sfr   US1CON3 = 0xA7;     //SPI1ݼĴ

/*USCI2*/
sfr   US2CON0 = 0xC4;     //SPI2ƼĴ0
sfr   US2CON1 = 0xC5;     //SPI2ƼĴ1
sfr   US2CON2 = 0xC6;     //SPI2ƼĴ2
sfr   US2CON3 = 0xC7;     //SPI2ݼĴ

sfr   OPINX   = 0xFE; 
sfr   OPREG   = 0xFF;
sfr   EXADH   = 0xF7;

/*˳*/
sfr   EXA0    = 0xE9;     //չۼ0
sfr   EXA1    = 0xEA;     //չۼ1
sfr   EXA2    = 0xEB;     //չۼ2
sfr   EXA3    = 0xEC;     //չۼ3
sfr   EXBL    = 0xED;     //չBĴ0
sfr   EXBH    = 0xEE;     //չBĴ1
sfr   OPERCON = 0xEF;     //ƼĴ

/*CRC*/
sfr   CRCINX  = 0xFC;	  //Check SumĴλ
sfr   CRCREG  = 0xFD;	  //Check SumĴλ

///* ------------------- λĴ-------------------- */
/*B*/
/*TKCON*/
/*ACC*/
/*PSW*/
sbit   CY	  = PSW^7;	  //־λ		    0:ӷλ޽λ߼λ޽λʱ		1:ӷλнλ߼λнλʱ
sbit   AC	  = PSW^6;	  //λ־λ	0:޽λλ		1:ӷʱbit3λнλbit3λнλʱ
sbit   F0	  = PSW^5;	  //û־λ
sbit   RS1	  = PSW^4;	  //Ĵѡλ
sbit   RS0	  = PSW^3;	  //Ĵѡλ
sbit   OV	  = PSW^2;	  //־λ
sbit   F1	  = PSW^1;	  //F1־
sbit   P	  = PSW^0;	  //ż־λ		0:ACC1ĸΪż0		1:ACC1ĸΪ

/*TXCON*/
sbit  TFX     = TXCON^7;
sbit  EXFX	  = TXCON^6;
sbit  RCLKX   = TXCON^5;
sbit  TCLKX	  = TXCON^4;
sbit  EXENX	  = TXCON^3;
sbit  TRX	  = TXCON^2;
sbit  TX      = TXCON^1;
sbit  CP	  = TXCON^0;

/*IP*/
sbit  IPADC	  = IP^6;	  //ADCжȿλ      0:趨 ADCжȨ ͡		1:趨 ADCжȨ ߡ
sbit  IPT2	  = IP^5;	  //Timer2жȿλ   0:趨 Timer2жȨ ͡     1:趨Timer2жȨ ߡ
sbit  IPUART  = IP^4;	  //UARTжȿλ	   0:趨UARTжȨ ͡		1:趨UARTжȨ ߡ
sbit  IPT1	  = IP^3;	  //Timer1жȿλ   0:趨 Timer 1жȨ ͡	1:趨 Timer 1жȨ ߡ
sbit  IPINT1  = IP^2;	  //INT1жȿλ	   0:趨INT1жȨ ͡		    1:趨INT1жȨ ߡ
sbit  IPT0	  = IP^1;	  //Timer0жȿλ   0:趨 Timer 0жȨ ͡	1:趨 Timer 0жȨ ߡ
sbit  IPINT0  = IP^0;     //INT0жȿλ	   0:趨INT0жȨ ͡		    1:趨INT0жȨ ߡ

/*IE*/
sbit  EA	  = IE^7;	  //жʹܵܿ	   0:رеж	    1:еж
sbit  EADC    = IE^6;	  //ADCжʹܿ	       0:رADCж		1:ADCж
sbit  ET2     = IE^5;	  //Timer2жʹܿ	   0:رTimer2ж     1:Timer2ж
sbit  EUART   = IE^4;	  //UARTжʹܿ	   0:رUARTж		1:UARTж
sbit  ET1     = IE^3;	  //Timer1жʹܿ	   0:رTIMER1ж	    1:TIMER1ж
sbit  EINT1   = IE^2;	  //INT1жʹܿ	   0:رINT1ж		1:INT1ж	
sbit  ET0	  = IE^1;	  //Timer0жʹܿ	   0:رTIMER0ж	    1:TIMER0ж
sbit  EINT0   = IE^0;	  //INT0жʹܿ	   0:رINT0ж       1:INT0ж

/*TCON*/
sbit  TF1	  = TCON^7;	  //T1ж־λ	T1жʱӲTF1Ϊ1жϣCPUӦʱӲ塰0
sbit  TR1	  = TCON^6;	  //ʱT1пλ	0:Timer1ֹ		1:Timer1ʼ
sbit  TF0	  = TCON^5;	  //T0ж־λ	T0жʱӲTF0Ϊ1жϣCPUӦʱӲ塰0
sbit  TR0	  = TCON^4;	  //ʱT0пλ	0:Timer0ֹ		1:Timer0ʼ

/*SCON*/
sbit  SM0     = SCON^7;
sbit  SM1	  = SCON^6;
sbit  SM2	  = SCON^5;
sbit  REN	  = SCON^4;
sbit  TB8	  = SCON^3;
sbit  RB8	  = SCON^2;
sbit  TI	  = SCON^1;
sbit  RI	  = SCON^0;

/******************* P0 ******************
*SC95F8523װδĹܽţ				   
*SC95F8522װδĹܽţP06/P07
*SC95F8521װδĹܽ: P06/P07/P02/P03/P04
*SC95F8520S(MSOP10)װδĹܽţP06/P07/P02/P03/P01/P04/P00
*SC95F8520M(SOP8)װδĹܽţP06/P07/P02/P03/P01/P04/P05/P00
******************************************/
sbit 	P07 = P0^7;
sbit 	P06 = P0^6;
sbit 	P05	= P0^5;
sbit 	P04	= P0^4;
sbit 	P03	= P0^3;
sbit 	P02	= P0^2;
sbit 	P01	= P0^1;
sbit 	P00	= P0^0;

/******************* P1 ****************** 
*SC95F8523װδĹܽţ
*SC95F8522װδĹܽţP16/P17
*SC95F8521װδĹܽţP16/P17
*SC95F8520S(MSOP10)װδĹܽţP16/P17/P14/P11
*SC95F8520M(SOP8)װδĹܽţP11/P14/P15/P16/P17
******************************************/
sbit 	P17	= P1^7;
sbit 	P16	= P1^6;
sbit 	P15	= P1^5;
sbit 	P14	= P1^4;
sbit 	P13	= P1^3;
sbit 	P12	= P1^2;
sbit 	P11	= P1^1;
sbit 	P10	= P1^0;

/******************* P2 ******************
*SC95F8523װδĹܽţ
*SC95F8522װδĹܽţP22/P23
*SC95F8521װδĹܽţP22/P23/P27
*SC95F8520S(MSOP10)װδĹܽţP22/P23/P27/P25/P26
*SC95F8520M(SOP8)װδĹܽţP22/P23/P27/P25/P26
******************************************/
sbit 	P27	= P2^7;
sbit 	P26	= P2^6;
sbit 	P25	= P2^5;
sbit 	P24	= P2^4;
sbit 	P23	= P2^3;
sbit 	P22	= P2^2;
sbit 	P21	= P2^1;
sbit 	P20	= P2^0;

/******************* P5 ******************
*SC95F8523װδĹܽţ
*SC95F8522װδĹܽţP50/P51
*SC95F8521װδĹܽţP50/P51
*SC95F8520S(MSOP10)װδĹܽţP50/P51
*SC95F8520M(SOP8)װδĹܽţP50/P51
******************************************/
sbit 	P51	= P5^1;
sbit 	P50	= P5^0;

/****************************************************************************
*ע⣺װδĹܽţΪǿģʽ
*ICѡͣʹõICͺ,ڳʼIOں󣬵ӦδܽŵIO;
*****************************************************************************/
#define  SC95F8522_NIO_Init()   {P0CON|=0xC0,P1CON|=0xC0,P2CON|=0x0C,P5CON|=0x03;}  // SC95F8522δIO
#define  SC95F8521_NIO_Init()   {P0CON|=0xDC,P1CON|=0xC0,P2CON|=0x8C,P5CON|=0x03;}  // SC95F8521δIO
#define  SC95F8520S_NIO_Init()  {P0CON|=0xDF,P1CON|=0xD2,P2CON|=0xEC,P5CON|=0x03;}  // SC95F8520S(10PIN)δIO
#define  SC95F8520M_NIO_Init()  {P0CON|=0xFF,P1CON|=0xF2,P2CON|=0xEC,P5CON|=0x03;}  // SC95F8520M(8PIN)δIO
#endif