#include "H/Function_Init.H"

//ѡһģʽ
#define  Uart2   0
#define  TWI2    1
#define  SPI2    2

#define  SSI2_Mode  TWI2

void Uart2_Init(uint Freq,unsigned long int baud);
void TWI2_Init(void);
void SPI2_Init(void);

bit Uart2SendFlag = 0;    //Uart2жϱ־λ
bit Uart2ReceiveFlag = 0; //Uart2жϱ־λ
bit SPI2Flag = 0;         //SPI2ݴɱ־λ
bit TWI2Flag = 0;         //TWI2жϱ־λ

/*****************************************************
*ƣvoid SSI2_Test(void)
*ܣSSI2
*ڲvoid
*ڲvoid
*****************************************************/
void SSI2_Test(void)
{
#if (SSI2_Mode == Uart2)
	Uart2_Init(32,9600);
	while(1)
	{
		US2CON3 = 0xAA;
		while(!Uart2SendFlag);
		Uart2SendFlag = 0;
	}
#endif
	
#if (SSI2_Mode == TWI2)
	TWI2_Init();
	while(1)
	{
		US2CON1 |= 0x20;    //ʼ
		while(!TWI2Flag);
        TWI2Flag = 0;		
		US2CON3 = 0x10;	    //͵ַ
        while(!TWI2Flag);
        TWI2Flag = 0;
        US2CON3 = 0x55;	    //͵ַ
        while(!TWI2Flag);
        TWI2Flag = 0;
		Delay(100);
		US2CON1 |= 0x10;
		Delay(100);
	}
#endif

#if (SSI2_Mode == SPI2)
	SPI2_Init();
	while(1)
	{
		US2CON2 = 0xAA;
		while(!SPI2Flag);
		SPI2Flag = 0;
        Delay(1000);
	}
#endif	
}
/*****************************************************
*ƣvoid Uart2_Init(uint Freq,unsigned long int baud)
*ܣUart2жϳʼ
*ڲFreq-Ƶbaud-
*ڲvoid
*****************************************************/
void Uart2_Init(uint Freq,unsigned long int baud)
{
	P1CON &= 0xCF;    //TX/RXΪ
	P1PH  |= 0x30;
	
	TMCON |= 0xC0;    //нӿSSI2ѡUart2ͨ
	US2CON0 = 0x50;   //ͨŷʽΪģʽһ
	US2CON1 = Freq*1000000/baud;   //ʵλ
	US2CON2 = (Freq*1000000/baud)>>8;   //ʸλ
	IE2 |= 0x02;      //SSI2ж
    EA = 1;	
}

/*****************************************************
*ƣvoid TWI2_Init(void)
*ܣTWI2ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void TWI2_Init(void)
{
	TMCON |= 0x80;   //ѡTWI2ģʽ
	US2CON0 = 0x80;  //ģʽ ʹӦ־λ
	US2CON1 = 0x05;  //---- xxxx  xΪʱ
	IE2 |= 0x02;
	EA = 1;
}

/*****************************************************
*ƣvoid SPI2_Init(void)
*ܣSPI2ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void SPI2_Init(void)
{
	TMCON |= 0X40;    //ѡSPI2ģʽ
	US2CON0 = 0x3F;   //SPI2Ϊ豸SCKʱΪߵƽSCKڵڶزɼݣʱΪFsys/128
	US2CON1 = 0x01;   //MSBȷͣ8λ䣬ж
	US2CON0 |= 0x80;  //SPI2
	IE2 |= 0x02;
	EA = 1;
}


/*****************************************************
*ƣvoid TWI2/PI/UART1_Int() interrupt 16
*ܣSSI2жϺ
*ڲvoid
*ڲvoid
*****************************************************/
#if (SSI2_Mode == Uart2)
void Uart2_Int() interrupt 16   //Uart2жϺ
{
	if(US2CON0&0x02)    //ͱ־λж
	{
		US2CON0 &= 0xFD;
		Uart2SendFlag = 1;
	}
	if((US2CON0&0x01))  //ձ־λж
	{
		US2CON0 &= 0xFE;
		Uart2ReceiveFlag = 1;
	}	
}
#endif

#if (SSI2_Mode == TWI2)
void TWI2_Int() interrupt 16     //TWI2жϺ
{
	if(US2CON0&0x40)
	{
		US2CON0 &= 0xbf;  //ж
		TWI2Flag = 1;
	}	
}
#endif 

#if (SSI2_Mode == SPI2)
void SpiInt(void) interrupt 16    //SPI2жϺ
{	  
	if(US2CON1&0X08)    //ͻձ־ж
	{
		US2CON1 &= ~0X08;
	}
	if(US2CON1&0X80)    //ݴ־λж
	{
		US2CON1 &= ~0X80;
		SPI2Flag = 1;
	}
}
#endif 