#include "H/Function_Init.H"

//ѡһģʽ
#define  Uart2   0
#define  TWI2    1
#define  SPI2    2

#define  USCI2_Mode  TWI2
#define TWI2_Mode 0//0:ģʽ   1ӻģʽ
#define SPI2_Mode 0 //0:ģʽ   1ӻģʽ

void Uart2_Init(uint Freq,unsigned long int baud);
void TWI2_Init(void);
void SPI2_Init(void);

bit Uart2SendFlag = 0;     //Uart2жϱ־λ
bit Uart2ReceiveFlag = 0;  //Uart2жϱ־λ
bit SPI2Flag = 0;         //SPI2ݴɱ־λ
bit TWI2Flag = 0;         //TWI2жϱ־λ

uint8_t TxXferCount2 = 0;  //SPI/TWIĿ
uint8_t RxXferCount2 = 0;  //SPI/TWIĿ 
volatile uint8_t Uart2_RxData[5];
uint8_t SPI2_Master_SendData[8] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
volatile uint8_t SPI2_Master_ReceiveData[8];
uint8_t SPI2_Slaver_SendData[8] = {0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F};
volatile uint8_t SPI2_Slaver_ReceiveData[8];

uint8_t TWI2_Master_SendData[8]={0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
volatile uint8_t TWI2_Master_ReceiveData[8];
uint8_t TWI2_Slaver_SendData[8]={0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F};
volatile uint8_t TWI2_Slaver_ReceiveData[8];
/*****************************************************
*ƣvoid USCI2_Test(void)
*ܣUSCI2
*ڲvoid
*ڲvoid
*****************************************************/
void USCI2_Test(void)
{
#if (USCI2_Mode == Uart2)
	int num1,num2;
	Uart2_Init(32,9600);
	while(1)
	{
		   for(num1=0;num1<5;num1++)
		{
			while(!Uart2ReceiveFlag);
			Uart2ReceiveFlag = 0;
			Uart2_RxData[num1] = US2CON3 ;
		}
		for(num2=0;num2<5;num2++)
		{
			US2CON3  = Uart2_RxData[num2];
		  	while(!Uart2SendFlag);
		    Uart2SendFlag = 0;
    }
	}
#endif
	
#if (USCI2_Mode == TWI2)
	TWI2_Init();
	while(1)
	{
		#if (TWI2_Mode == 0)  //
			{
				US2CON1 |= 0x20;    //ʼ	
				while(TWI2Flag == 0);
				TWI2Flag = 0; 
				US2CON3 = 0x02|0X01;	    //͵ַд
				while(TWI2Flag == 0);
				TWI2Flag = 0; 

		/* ݽչ */
				do
				{
						if(RxXferCount2 ==7)
					{
							US2CON0 &= 0XF7;    	
					}
				
					 while(TWI2Flag == 0);
					 TWI2Flag = 0; 
					 TWI2_Master_ReceiveData[RxXferCount2] = US2CON3;             //TWI
					 RxXferCount2++;	
				}
				while(RxXferCount2 < 8);
			
			 RxXferCount2=0;
				/* ǷɣҪͽźţֹռ */
			 US2CON0 |= 0X08; //AAʹλ,UAC
			 US2CON1 |= 0x10;
			 Delay(500);
			}
	#endif
	#if (TWI2_Mode == 1)  //ӻ  
		 {  
			 
			 TWI2Flag = 0; 
			 while((0x07 & US2CON0)!=0x00);//ж״̬Ƿص״̬
			 
			  while((0x07 & US2CON0)!=0x03);//ж״̬Ƿ״̬
			  while(TWI2Flag == 0);
			 TWI2Flag = 0; 
			TxXferCount2=0;
			 while(TxXferCount2 < 8)
			 {

				US2CON3 = TWI2_Slaver_SendData[TxXferCount2];             //TWI
				while(TWI2Flag == 0);
				TWI2Flag = 0; 
				TxXferCount2++;

			 }
				US2CON3 = TWI2_Slaver_SendData[0];
			 
			 while((0x07 & US2CON0)!=0x00);//ж״̬Ƿص״̬

				TxXferCount2=0;
				Delay(100);
			 }
	#endif
	}
#endif

#if (USCI2_Mode == SPI2)
	SPI2_Init();
	while(1)
	{
     #if (SPI2_Mode == 0)  //
	   TxXferCount2 = 0;
    while(TxXferCount2 <  8)//жǷ
    {
     
      US2CON2 = SPI2_Master_SendData[TxXferCount2];
      while(SPI2Flag == 0);	//ȴ
      SPI2Flag = 0;		
      SPI2_Master_ReceiveData[TxXferCount2]=US2CON2;
      TxXferCount2 ++;	//
      
		}
		Delay(500);;
		

     #elif (SPI2_Mode == 1) //ӻ
 
 
	   while(RxXferCount2 <8)
    {
			 US2CON2=SPI2_Slaver_SendData[RxXferCount2];
      /* ȴSPIжϱ־λ */
      
			while(SPI2Flag == 0);	//ȴ
		   
      SPI2Flag = 0;		
      SPI2_Slaver_ReceiveData[RxXferCount2] = US2CON2;	
      /* ȴSPIжϱ־λ */
      RxXferCount2++;	//1
      
      }
		 Delay(100);
	  RxXferCount2 = 0;
		
     #endif
	}
#endif	
}
/*****************************************************
*ƣvoid Uart2_Init(uint Freq,unsigned long int baud)
*ܣUart2жϳʼ
*ڲFreq-Ƶbaud-
*ڲvoid
*****************************************************/
void Uart2_Init(uint Freq,unsigned long int baud)
{
	P1CON &= 0xCF;    //TX/RXΪ
	P1PH  |= 0x30;
	
	TMCON |= 0xC0;     //нӿUSCI2ѡUart2ͨ
	US2CON0 = 0x50;    //ͨŷʽΪģʽһ
	US2CON1 = Freq*1000000/baud;   //ʵλ
	US2CON2 = (Freq*1000000/baud)>>8;    //ʸλ
	IE2 |= 0x02;       //USCI2ж
    EA = 1;	
}

/*****************************************************
*ƣvoid TWI2_Init(void)
*ܣTWI2ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void TWI2_Init(void)
{
	#if (TWI2_Mode == 0)	
 { US2CON3 = TWI2_Slaver_SendData[0];   }   //ӻԤ׼
#endif
	TMCON |= 0x80;   //ѡTWI2ģʽ
	US2CON0 = 0x88;  //ģʽ ʹӦ־λ
	US2CON1 = 0x40;  //---- xxxx  xΪʱ
    US2CON2 = 0x02;  //ӻַ
	IE2 |= 0x02;
	EA = 1;
}

/*****************************************************
*ƣvoid SPI2_Init(void)
*ܣSPI2ʼ
*ڲvoid
*ڲvoid
*****************************************************/
void SPI2_Init(void)
{
	TMCON |= 0X40;    //ѡSPI2ģʽ
#if (SPI2_Mode == 0)	
 {  US2CON0 = 0x23;   }   //SPIXΪ豸SCKʱΪ͵ƽSCKڵһزɼݣʱΪFsy/8
#elif (SPI2_Mode == 1)	
 {  US2CON0 = 0x03; }   //SPIXΪ豸SCKʱΪ͵ƽSCKڵһزɼݣʱΪFsy/8
#endif 
	US2CON1 = 0x00;   //MSBȷͣ8λ䣬ж
	US2CON0 |= 0x80;  //SPI2
	IE2 |= 0x02;
	EA = 1;
}


/*****************************************************
*ƣvoid TWI2/PI/Uart2_Int() interrupt 7
*ܣUSCI2жϺ
*ڲvoid
*ڲvoid
*****************************************************/
#if (USCI2_Mode == Uart2)
void Uart2_Int() interrupt 16   //Uart2жϺ
{
	if(US2CON0&0x02)   //ͱ־λж
	{
		US2CON0 &= 0xFD;
		Uart2SendFlag = 1;
	}
	if((US2CON0&0x01))  //ձ־λж
	{
		US2CON0 &= 0xFE;
		Uart2ReceiveFlag = 1;
	}	
}
#endif

#if (USCI2_Mode == TWI2)
void TWI2_Int() interrupt 16    //TWI2жϺ
{
	if(US2CON0&0x40)
	{
		US2CON0 &= 0xbf;  //ж
		TWI2Flag = 1;
	}	
}
#endif 

#if (USCI2_Mode == SPI2)
void SpiInt(void) interrupt 16    //SPI2жϺ
{	  
	if(US2CON1&0X08)     //ͻձ־ж
	{
		US2CON1 &= ~0X08;
	}
	if(US2CON1&0X80)   //ݴ־λж
	{
		US2CON1 &= ~0X80;
		SPI2Flag = 1;
	}
}
#endif 